<?php
/**
 * Omega Hair Salon functions and definitions
 * @package Omega Hair Salon
 */

if ( ! function_exists( 'omega_hair_salon_after_theme_support' ) ) :

	function omega_hair_salon_after_theme_support() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support('woocommerce');
        add_theme_support('wc-product-gallery-zoom');
        add_theme_support('wc-product-gallery-lightbox');
        add_theme_support('wc-product-gallery-slider');
        add_theme_support('woocommerce', array(
            'gallery_thumbnail_image_width' => 300,
        ));

		add_theme_support(
			'custom-background',
			array(
				'default-color' => 'ffffff',
			)
		);

		$GLOBALS['content_width'] = apply_filters( 'omega_hair_salon_content_width', 1140 );
		
		add_theme_support( 'post-thumbnails' );

        load_theme_textdomain( 'omega-hair-salon', get_template_directory() . '/languages' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 270,
				'width'       => 90,
				'flex-height' => true,
				'flex-width'  => true,
			)
		);
		
		add_theme_support( 'title-tag' );

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'script',
				'style',
			)
		);

		add_theme_support( 'post-formats', array(
			'video',  
			'audio',  
			'gallery',
			'quote',  
			'image',  
			'link',   
			'status', 
			'aside',  
			'chat',   
		) );
		
		add_theme_support( 'align-wide' );
		add_theme_support( 'responsive-embeds' );
		add_theme_support( 'wp-block-styles' );

		add_editor_style('/lib/custom/css/editor-style.css');

        require get_template_directory() . '/inc/metabox.php';
        require get_template_directory() . '/inc/homepage-setup/homepage-setup-settings.php';


        if (! defined( 'OMEGA_HAIR_SALON_DOCS_PRO' ) ){
        define('OMEGA_HAIR_SALON_DOCS_PRO',__('https://layout.omegathemes.com/steps/pro-omega-hair-salon/','omega-hair-salon'));
        }
        if (! defined( 'OMEGA_HAIR_SALON_BUY_NOW' ) ){
        define('OMEGA_HAIR_SALON_BUY_NOW',__('https://www.omegathemes.com/products/hair-salon-wordpress-theme','omega-hair-salon'));
        }
        if (! defined( 'OMEGA_HAIR_SALON_SUPPORT_FREE' ) ){
        define('OMEGA_HAIR_SALON_SUPPORT_FREE',__('https://wordpress.org/support/theme/omega-hair-salon/','omega-hair-salon'));
        }
        if (! defined( 'OMEGA_HAIR_SALON_REVIEW_FREE' ) ){
        define('OMEGA_HAIR_SALON_REVIEW_FREE',__('https://wordpress.org/support/theme/omega-hair-salon/reviews/#new-post/','omega-hair-salon'));
        }
        if (! defined( 'OMEGA_HAIR_SALON_DEMO_PRO' ) ){
        define('OMEGA_HAIR_SALON_DEMO_PRO',__('https://layout.omegathemes.com/omega-hair-salon/','omega-hair-salon'));
        }
        if (! defined( 'OMEGA_HAIR_SALON_LITE_DOCS_PRO' ) ){
        define('OMEGA_HAIR_SALON_LITE_DOCS_PRO',__('https://layout.omegathemes.com/steps/free-omega-hair-salon/','omega-hair-salon'));
        }
        if (! defined( 'OMEGA_HAIR_SALON_BUNDLE_BUTTON' ) ){
            define('OMEGA_HAIR_SALON_BUNDLE_BUTTON',__('https://www.omegathemes.com/products/wp-theme-bundle','omega-hair-salon'));
        }

	}

endif;

add_action( 'after_setup_theme', 'omega_hair_salon_after_theme_support' );

/**
 * Register and Enqueue Styles.
 */
function omega_hair_salon_register_styles() {

	wp_enqueue_style( 'dashicons' );

    $omega_hair_salon_theme_version = wp_get_theme()->get( 'Version' );
	$omega_hair_salon_fonts_url = omega_hair_salon_fonts_url();
    if( $omega_hair_salon_fonts_url ){
    	require_once get_theme_file_path( 'lib/custom/css/wptt-webfont-loader.php' );
        wp_enqueue_style(
			'omega-hair-salon-google-fonts',
			wptt_get_webfont_url( $omega_hair_salon_fonts_url ),
			array(),
			$omega_hair_salon_theme_version
		);
    }

    wp_enqueue_style( 'swiper', get_template_directory_uri() . '/lib/swiper/css/swiper-bundle.min.css');
	wp_enqueue_style( 'omega-hair-salon-style', get_stylesheet_uri(), array(), $omega_hair_salon_theme_version );

	wp_enqueue_style( 'omega-hair-salon-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom_css.php' );
	wp_add_inline_style( 'omega-hair-salon-style',$omega_hair_salon_custom_css );

	$omega_hair_salon_css = '';

	if ( get_header_image() ) :

		$omega_hair_salon_css .=  '
			header#site-header{
				background-image: url('.esc_url(get_header_image()).');
				-webkit-background-size: cover !important;
				-moz-background-size: cover !important;
				-o-background-size: cover !important;
				background-size: cover !important;
			}';

	endif;

	wp_add_inline_style( 'omega-hair-salon-style', $omega_hair_salon_css );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}	

	wp_enqueue_script( 'imagesloaded' );
    wp_enqueue_script( 'masonry' );
	wp_enqueue_script( 'swiper', get_template_directory_uri() . '/lib/swiper/js/swiper-bundle.min.js', array('jquery'), '', 1);
	wp_enqueue_script( 'omega-hair-salon-custom', get_template_directory_uri() . '/lib/custom/js/theme-custom-script.js', array('jquery'), '', 1);

    // Global Query
    if( is_front_page() ){

    	$omega_hair_salon_posts_per_page = absint( get_option('posts_per_page') );
        $omega_hair_salon_c_paged = ( get_query_var( 'page' ) ) ? absint( get_query_var( 'page' ) ) : 1;
        $omega_hair_salon_posts_args = array(
            'posts_per_page'        => $omega_hair_salon_posts_per_page,
            'paged'                 => $omega_hair_salon_c_paged,
        );
        $omega_hair_salon_posts_qry = new WP_Query( $omega_hair_salon_posts_args );
        $max = $omega_hair_salon_posts_qry->max_num_pages;

    }else{
        global $wp_query;
        $max = $wp_query->max_num_pages;
        $omega_hair_salon_c_paged = ( get_query_var( 'paged' ) > 1 ) ? get_query_var( 'paged' ) : 1;
    }

    $omega_hair_salon_default = omega_hair_salon_get_default_theme_options();
    $omega_hair_salon_pagination_layout = get_theme_mod( 'omega_hair_salon_pagination_layout',$omega_hair_salon_default['omega_hair_salon_pagination_layout'] );
}

add_action( 'wp_enqueue_scripts', 'omega_hair_salon_register_styles',200 );

function omega_hair_salon_admin_enqueue_scripts_callback() {
    if ( ! did_action( 'wp_enqueue_media' ) ) {
    wp_enqueue_media();
    }
    wp_enqueue_script('omega-hair-salon-uploaderjs', get_stylesheet_directory_uri() . '/lib/custom/js/uploader.js', array(), "1.0", true);
}
add_action( 'admin_enqueue_scripts', 'omega_hair_salon_admin_enqueue_scripts_callback' );

/**
 * Register navigation menus uses wp_nav_menu in five places.
 */
function omega_hair_salon_menus() {

	$omega_hair_salon_locations = array(
		'omega-hair-salon-primary-menu'  => esc_html__( 'Primary Menu', 'omega-hair-salon' ),
	);

	register_nav_menus( $omega_hair_salon_locations );
}

add_action( 'init', 'omega_hair_salon_menus' );

add_filter('loop_shop_columns', 'omega_hair_salon_loop_columns');
if (!function_exists('omega_hair_salon_loop_columns')) {
	function omega_hair_salon_loop_columns() {
		$omega_hair_salon_columns = get_theme_mod( 'omega_hair_salon_per_columns', 3 );
		return $omega_hair_salon_columns;
	}
}

add_filter( 'loop_shop_per_page', 'omega_hair_salon_per_page', 20 );
function omega_hair_salon_per_page( $omega_hair_salon_cols ) {
  	$omega_hair_salon_cols = get_theme_mod( 'omega_hair_salon_product_per_page', 9 );
	return $omega_hair_salon_cols;
}

add_filter( 'woocommerce_output_related_products_args', 'omega_hair_salon_products_args' );

function omega_hair_salon_products_args( $omega_hair_salon_args ) {

    $omega_hair_salon_args['posts_per_page'] = get_theme_mod( 'omega_hair_salon_custom_related_products_number', 6 );

    $omega_hair_salon_args['columns'] = get_theme_mod( 'omega_hair_salon_custom_related_products_number_per_row', 3 );

    return $omega_hair_salon_args;
}

require get_template_directory() . '/inc/custom-header.php';
require get_template_directory() . '/classes/class-svg-icons.php';
require get_template_directory() . '/classes/class-walker-menu.php';
require get_template_directory() . '/inc/customizer/customizer.php';
require get_template_directory() . '/inc/custom-functions.php';
require get_template_directory() . '/inc/template-tags.php';
require get_template_directory() . '/classes/body-classes.php';
require get_template_directory() . '/inc/widgets/widgets.php';
require get_template_directory() . '/inc/pagination.php';
require get_template_directory() . '/lib/breadcrumbs/breadcrumbs.php';
require get_template_directory() . '/lib/custom/css/dynamic-style.php';


function omega_hair_salon_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'omega_hair_salon_remove_customize_register', 11 );

// Services Price Meta
function omega_hair_salon_custom_meta_price() {
    add_meta_box( 'bn_meta', __( 'Services Price', 'omega-hair-salon' ), 'omega_hair_salon_meta_callback_price', 'post', 'normal', 'high' );
}

if (is_admin()){
  add_action('admin_menu', 'omega_hair_salon_custom_meta_price');
}

function omega_hair_salon_meta_callback_price( $post ) {
    wp_nonce_field( basename( __FILE__ ), 'omega_hair_salon_price_meta_nonce' );
    $omega_hair_salon_stored_meta = get_post_meta( $post->ID );
    $omega_hair_salon_price = get_post_meta( $post->ID, 'omega_hair_salon_price', true );
    ?>
    <div id="testimonials_custom_stuff">
        <table id="list">
            <tbody id="the-list" data-wp-lists="list:meta">
                <tr id="meta-8">
                    <td class="left">
                        <?php esc_html_e( 'Services Price', 'omega-hair-salon' )?>
                    </td>
                    <td class="left">
                        <input type="text" name="omega_hair_salon_price" id="omega_hair_salon_price" value="<?php echo esc_attr($omega_hair_salon_price); ?>" />
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
    <?php
}

/* Saves the custom meta input */
function omega_hair_salon_meta_save( $post_id ) {
    if (!isset($_POST['omega_hair_salon_price_meta_nonce']) || !wp_verify_nonce( strip_tags( wp_unslash( $_POST['omega_hair_salon_price_meta_nonce']) ), basename(__FILE__))) {
        return;
    }

    if (!current_user_can('edit_post', $post_id)) {
        return;
    }

    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
        return;
    }

    // Save Services Price
    if( isset( $_POST[ 'omega_hair_salon_price' ] ) ) {
        update_post_meta( $post_id, 'omega_hair_salon_price', strip_tags( wp_unslash( $_POST[ 'omega_hair_salon_price' ]) ) );
    }
}
add_action( 'save_post', 'omega_hair_salon_meta_save' );

// Apply styles based on customizer settings

function omega_hair_salon_radio_sanitize(  $omega_hair_salon_input, $omega_hair_salon_setting  ) {
	$omega_hair_salon_input = sanitize_key( $omega_hair_salon_input );
	$omega_hair_salon_choices = $omega_hair_salon_setting->manager->get_control( $omega_hair_salon_setting->id )->choices;
	return ( array_key_exists( $omega_hair_salon_input, $omega_hair_salon_choices ) ? $omega_hair_salon_input : $omega_hair_salon_setting->default );
}
require get_template_directory() . '/inc/general.php';

function omega_hair_salon_sticky_sidebar_enabled() {
    $omega_hair_salon_sticky_sidebar = get_theme_mod('omega_hair_salon_sticky_sidebar', true);
    
    if ($omega_hair_salon_sticky_sidebar == false) {
        $omega_hair_salon_custom_css = ".widget-area-wrapper { position: relative !important; }";
        wp_add_inline_style('omega-hair-salon-style', $omega_hair_salon_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'omega_hair_salon_sticky_sidebar_enabled');

// NOTICE FUNCTION

function omega_hair_salon_admin_notice() { 
    global $pagenow;
    $theme_args = wp_get_theme();
    $meta = get_option( 'omega_hair_salon_admin_notice' );
    $name = $theme_args->get( 'Name' );
    $current_screen = get_current_screen();

    if ( ! $meta ) {
        if ( is_network_admin() ) {
            return;
        }

        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }

        if ( $current_screen->base != 'appearance_page_omegahairsalon-wizard' ) {
            ?>
            <div class="notice notice-success notice-content">
                <h2><?php esc_html_e('Welcome! Thank you for choosing Omega Hair Salon. Let’s Set Up Your Website!', 'omega-hair-salon') ?> </h2>
                <p><?php esc_html_e('Before you dive into customization, let’s go through a quick setup process to ensure everything runs smoothly. Click below to start setting up your website in minutes!', 'omega-hair-salon') ?> </p>
                <div class="info-link">
                    <a href="<?php echo esc_url( admin_url( 'themes.php?page=omegahairsalon-wizard' ) ); ?>"><?php esc_html_e('Get Started with Omega Hair Salon', 'omega-hair-salon'); ?></a>
                </div>
                <p class="dismiss-link"><strong><a href="?omega_hair_salon_admin_notice=1"><?php esc_html_e( 'Dismiss', 'omega-hair-salon' ); ?></a></strong></p>
            </div>
            <?php
        }
    }
}
add_action( 'admin_notices', 'omega_hair_salon_admin_notice' );

if ( ! function_exists( 'omega_hair_salon_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
 */
function omega_hair_salon_update_admin_notice() {
    if ( isset( $_GET['omega_hair_salon_admin_notice'] ) && $_GET['omega_hair_salon_admin_notice'] == '1' ) {
        update_option( 'omega_hair_salon_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'omega_hair_salon_update_admin_notice' );

// After Switch theme function
add_action( 'after_switch_theme', 'omega_hair_salon_getstart_setup_options' );
function omega_hair_salon_getstart_setup_options() {
    update_option( 'omega_hair_salon_admin_notice', false );
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );